# Isolation Forest (ML\_ISF)

Isolation Forest is an unsupervised machine learning algorithm designed for anomaly detection. It efficiently identifies outliers in a dataset by creating random binary trees that isolate anomalies with fewer tree traversals compared to normal data points. The algorithm measures the average path length needed to isolate an observation, and anomalies are expected to have shorter path lengths due to their rarity and distinctiveness.&#x20;

Isolation Forest is particularly effective for large datasets with high-dimensional features, providing a scalable and accurate solution for detecting anomalies without the need for labeled data.

## Sample Request

Build an Isolation Forest model named, *"IsolateForest"*

```javascript
{
    "project_id": 1,
    "parent_id": 7,
    "block_id": 8,
    "function_code": "ML_ISF",
    "args": {
        "model_name": "IsolateForest",
        "random_state": 0
    }
}
```

## Building a Isolation Forest Anomaly Detection model

## Isolation Forest

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                               |
| ------------------------------------------------ | ------ | --------------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>    | int    | The `id` of the current project                           |
| block\_id<mark style="color:red;">\*</mark>      | int    | The `id` of the current block                             |
| function\_code<mark style="color:red;">\*</mark> | string | The function code for current block                       |
| parent\_id<mark style="color:red;">\*</mark>     | int    | The `id` of the previous block                            |
| args                                             | object | Block arguments                                           |
| model\_name                                      | String | Name of the model to be used for prediction.              |
| random\_state                                    | int    | Controls the randomness of the estimator (defaults to 0). |

{% tabs %}
{% tab title="200 Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 8,
        "project": 1,
        "block_id": 8,
        "parent_id": 7,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"SimpleModel\": {\"function_code\": \"ML_R_3\", \"model_url\": ""}}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

<pre class="language-javascript"><code class="lang-javascript">const project_id = 1
const parent_id = 7
const block_id = 8

decisionTreeRegression = await client.isolation_forest(project_id, parent_id, block_id, {
<strong>    model_name: "IsolateForest"
</strong>});
</code></pre>

{% endtab %}
{% endtabs %}

## Sample Request

Make predictions with the pre-built model passing an optional test data.

```javascript
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "ML_ISF_P",
    "args": {
        "model_name": "IsoslateForest",
        "test_data": null
    }
}
```

## Detecting Anomalies with Isolation Forest&#x20;

## Isolation Forest Predict

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                                            |
| ------------------------------------------------ | ------ | ---------------------------------------------------------------------- |
| model\_name<mark style="color:red;">\*</mark>    | String | Name of previously trained model to be used for detection              |
| test\_data                                       | String | Input data for prediction. Defaults to `x_train_url` in StateManagment |
| project\_id<mark style="color:red;">\*</mark>    | int    | ID of the current project                                              |
| block\_id<mark style="color:red;">\*</mark>      | int    | ID of the current block                                                |
| parent\_id<mark style="color:red;">\*</mark>     | int    | ID of the previous block                                               |
| function\_code<mark style="color:red;">\*</mark> | String | Function code for the current block                                    |

{% tabs %}
{% tab title="200: OK Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"y_pred_url\": ""}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

```javascript
const project_id = 1
const parent_id = 7
const block_id = 8

await client.isolation_forest_predict(project_id, parent_id, block_id, {
   model_name: "IsolateForest",
});
```

{% endtab %}
{% endtabs %}

## Sample Request

Evaluate anomaly detection model performance

```javascript
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "ML_ISF_M",
    "args": {
        "model_name": "IsoslateForest",
    }
}
```

## Evaluating Anomaly Detection with Isolation Forest&#x20;

## Isolation Forest Metrics

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                               |
| ------------------------------------------------ | ------ | --------------------------------------------------------- |
| model\_name<mark style="color:red;">\*</mark>    | String | Name of previously trained model to be used for detection |
| project\_id<mark style="color:red;">\*</mark>    | int    | ID of the current project                                 |
| block\_id<mark style="color:red;">\*</mark>      | int    | ID of the current block                                   |
| parent\_id<mark style="color:red;">\*</mark>     | int    | ID of the previous block                                  |
| function\_code<mark style="color:red;">\*</mark> | String | Function code for the current block                       |

{% tabs %}
{% tab title="200: OK Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": "{\"y_pred_url\": ""}"
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```python
# Some codethon
```

{% endtab %}

{% tab title="Node" %}

<pre><code><strong>// Some code
</strong></code></pre>

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.autogon.ai/autogon-engine-studio/machine-learning/isolation-forest-ml_isf.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
